/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */

import * as beet from "@metaplex-foundation/beet";
import * as web3 from "@solana/web3.js";
import {
  ReduceOrderParams,
  reduceOrderParamsBeet,
} from "../types/ReduceOrderParams";

/**
 * @category Instructions
 * @category ReduceOrderWithFreeFunds
 * @category generated
 */
export type ReduceOrderWithFreeFundsInstructionArgs = {
  params: ReduceOrderParams;
};
/**
 * @category Instructions
 * @category ReduceOrderWithFreeFunds
 * @category generated
 */
export const ReduceOrderWithFreeFundsStruct = new beet.BeetArgsStruct<
  ReduceOrderWithFreeFundsInstructionArgs & {
    instructionDiscriminator: number;
  }
>(
  [
    ["instructionDiscriminator", beet.u8],
    ["params", reduceOrderParamsBeet],
  ],
  "ReduceOrderWithFreeFundsInstructionArgs"
);
/**
 * Accounts required by the _ReduceOrderWithFreeFunds_ instruction
 *
 * @property [] phoenixProgram Phoenix program
 * @property [] logAuthority Phoenix log authority
 * @property [_writable_] market This account holds the market state
 * @property [_writable_, **signer**] trader
 * @category Instructions
 * @category ReduceOrderWithFreeFunds
 * @category generated
 */
export type ReduceOrderWithFreeFundsInstructionAccounts = {
  phoenixProgram: web3.PublicKey;
  logAuthority: web3.PublicKey;
  market: web3.PublicKey;
  trader: web3.PublicKey;
};

export const reduceOrderWithFreeFundsInstructionDiscriminator = 5;

/**
 * Creates a _ReduceOrderWithFreeFunds_ instruction.
 *
 * @param accounts that will be accessed while the instruction is processed
 * @param args to provide as instruction data to the program
 *
 * @category Instructions
 * @category ReduceOrderWithFreeFunds
 * @category generated
 */
export function createReduceOrderWithFreeFundsInstruction(
  accounts: ReduceOrderWithFreeFundsInstructionAccounts,
  args: ReduceOrderWithFreeFundsInstructionArgs,
  programId = new web3.PublicKey("PhoeNiXZ8ByJGLkxNfZRnkUfjvmuYqLR89jjFHGqdXY")
) {
  const [data] = ReduceOrderWithFreeFundsStruct.serialize({
    instructionDiscriminator: reduceOrderWithFreeFundsInstructionDiscriminator,
    ...args,
  });
  const keys: web3.AccountMeta[] = [
    {
      pubkey: accounts.phoenixProgram,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: accounts.logAuthority,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: accounts.market,
      isWritable: true,
      isSigner: false,
    },
    {
      pubkey: accounts.trader,
      isWritable: true,
      isSigner: true,
    },
  ];

  const ix = new web3.TransactionInstruction({
    programId,
    keys,
    data,
  });
  return ix;
}
